
#include <stdio.h>

struct POSIZIONE
{
 unsigned char giorno;
 unsigned char mese;
 unsigned short anno;
 unsigned char ora;
 unsigned char minuti;
 unsigned char secondi;
 signed char gradi_latitudine;
 unsigned char primi_latitudine;
 unsigned char secondi_latitudine;
 signed short gradi_longitudine;
 unsigned char primi_longitudine;
 unsigned char secondi_longitudine;
};


void main(int argc, char* argv[])
{
 FILE *sorgente, *destinazione;
 unsigned int giorno;
 unsigned int mese;
 unsigned int anno;
 unsigned int ora;
 unsigned int minuti;
 unsigned int secondi;
 unsigned int gradi_latitudine;
 unsigned int primi_latitudine;
 unsigned int secondi_latitudine;
 char orientamento_latitudine;
 unsigned int gradi_longitudine;
 unsigned int primi_longitudine;
 unsigned int secondi_longitudine;
 char orientamento_longitudine;
 struct POSIZIONE posizione;


 if (argc != 3)
   {
	printf("Errore: fornire i nomi dei file sorgente e destinazione come argomenti!\r\n");
	return;
   }

 // apertura file
 sorgente = fopen(argv[1], "rt");
 if (sorgente == NULL)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[1]);
	return;
   }
 destinazione = fopen(argv[2], "wb");
 if (destinazione == NULL)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[2]);
	fclose(sorgente);
	return;
   }

 while (!feof(sorgente))
      {
	   // acquisizione campi di una riga del file testuale
	   fscanf(sorgente, "%u:%u:%u,", &ora, &minuti, &secondi);
	   fscanf(sorgente, "%u/%u/%u,", &giorno, &mese, &anno);
	   fscanf(sorgente, "%u%u'%u\"%c,", &gradi_latitudine, &primi_latitudine, &secondi_latitudine, &orientamento_latitudine);
	   fscanf(sorgente, "%u%u'%u\"%c\r\n", &gradi_longitudine, &primi_longitudine, &secondi_longitudine, &orientamento_longitudine);
	   // costruzione e scrittura record file binario
	   posizione.anno = (unsigned short)anno;
	   posizione.giorno = (unsigned char)giorno;
	   if (orientamento_latitudine == 'N')
	     posizione.gradi_latitudine = (signed char)gradi_latitudine;
	   else
		   posizione.gradi_latitudine = -(signed char)gradi_latitudine;
	   if (orientamento_longitudine == 'E')
	     posizione.gradi_longitudine = (signed short)gradi_longitudine;
	   else
		   posizione.gradi_longitudine = -(signed short)gradi_longitudine;
	   posizione.mese = (unsigned char)mese;
	   posizione.minuti = (unsigned char)minuti;
	   posizione.ora = (unsigned char)ora;
	   posizione.primi_latitudine = (unsigned char)primi_latitudine;
	   posizione.primi_longitudine = (unsigned char)primi_longitudine;
	   posizione.secondi = (unsigned char)secondi;
	   posizione.secondi_latitudine = (unsigned char)secondi_latitudine;
	   posizione.secondi_longitudine = (unsigned char)secondi_longitudine;
	   fwrite(&posizione, sizeof(posizione), 1, destinazione);
      }
 // chiusura file
 fclose(sorgente);
 fclose(destinazione);
}
